<template>
  <v-menu
    v-if="isReviewer"
    open-on-hover
    bottom
    offset-y
  >
    <template #activator="{ on }">
      <v-btn
        icon
        v-on="on"
      >
        <v-icon>menu</v-icon>
      </v-btn>
    </template>
    <v-list>
      <v-list-item
        v-for="item in items"
        :key="item.title"
        @click="item.action"
      >
        <v-list-item-title>{{ item.title }}</v-list-item-title>
      </v-list-item>
    </v-list>
  </v-menu>
</template>

<script>
import { activateAllStudentAccess,
  deactivateAllStudentAccess } from '@/api'
import { actions } from '@/store/actions'
import { Authentication } from '@/store/modules/authentication'

export default {
  name: 'StudentListMenu',
  computed: {
    studentsActive () {
      const firstStudent = Object.values(this.$store.state.students)[0]
      return firstStudent ? firstStudent.isActive === true : false
    },
    isReviewer () {
      return Authentication.isReviewer
    },
    items () {
      return [
        {
          title: this.studentsActive
            ? 'Remove participant access'
            : 'Grant participant access',
          action: this.changeStudentsAccess
        }
      ]
    }
  },
  methods: {
    updateStudentData () {
      actions.getStudents().catch(() => {
        this.$notify({
          title: 'ERROR',
          text: 'Unable to update student data!',
          type: 'error'
        })
      })
    },
    changeStudentsAccess () {
      if (this.studentsActive) {
        deactivateAllStudentAccess().then(() => {
          this.updateStudentData()
        }).catch(() => {
          this.$notify({
            title: 'ERROR',
            text: 'Unable to disable access',
            type: 'error'
          })
        })
      } else {
        activateAllStudentAccess().then(() => {
          this.updateStudentData()
        }).catch(() => {
          this.$notify({
            title: 'ERROR',
            text: 'Unable to activate access',
            type: 'error'
          })
        })
      }
    }
  }
}
</script>

<style scoped>

</style>
